Summary:    A collection of SNMP protocol tools and libraries
Name:       net-snmp
Version:    5.9.3
Release:    6%{?dist}
License:    BSD
URL:        http://net-snmp.sourceforge.net/
Source0:    https://downloads.sourceforge.net/project/net-snmp/net-snmp/%{version}/net-snmp-%{version}.tar.gz
Source1:    net-snmp.conf
Source2:    net-snmp-tmpfs.conf
Source3:    snmpd.service
Source4:    snmptrapd.service

Patch3001:  net-snmp-5.9-pie.patch
Patch3002:  net-snmp-5.9-dir-fix.patch
Patch3003:  net-snmp-5.9-multilib.patch
Patch3004:  net-snmp-5.9-test-debug.patch
Patch3005:  net-snmp-5.7.2-cert-path.patch
Patch3006:  net-snmp-5.9-cflags.patch
Patch3007:  net-snmp-5.8-Remove-U64-typedef.patch
Patch3008:  net-snmp-5.7.3-iterator-fix.patch
Patch3009:  net-snmp-5.9-autofs-skip.patch
Patch3010:  net-snmp-5.9-coverity.patch
Patch3011:  net-snmp-5.8-expand-SNMPCONFPATH.patch
Patch3012:  net-snmp-5.8-duplicate-ipAddress.patch
Patch3013:  net-snmp-5.9-memory-reporting.patch
Patch3014:  net-snmp-5.8-man-page.patch
Patch3015:  net-snmp-5.8-ipAddress-faster-load.patch
Patch3016:  net-snmp-5.8-rpm-memory-leak.patch
Patch3017:  net-snmp-5.9-aes-config.patch
Patch3018:  net-snmp-5.8-clientaddr-error-message.patch
Patch3019:  net-snmp-5.9-intermediate-certs.patch
Patch3020:  net-snmp-5.9.1-remove-des.patch
Patch3021:  net-snmp-5.9.1-autoconf.patch
Patch3022:  net-snmp-libs-misunderstanding.patch
Patch3023:  net-snmp-5.9-CVE-2022-44792-44793.patch
Patch3024:  net-snmp-5.9-ipv6-disable-leak.patch
Patch3025:  net-snmp-5.9-sendmsg-error-code.patch
Patch3026:  net-snmp-5.8-modern-rpm-api.patch
Patch3027:  net-snmp-5.9-python3.patch

BuildRequires:   gcc, autoconf, automake, systemd
BuildRequires:   openssl-devel, bzip2-devel, elfutils-devel, net-tools, mariadb-connector-c-devel
BuildRequires:   libselinux-devel, elfutils-libelf-devel, rpm-devel, chrpath
BuildRequires:   perl-devel, perl(ExtUtils::Embed), python3-devel, python3-setuptools, procps
BuildRequires:   perl(:VERSION) >= 5.6, perl(AutoLoader), perl(blib), perl(Carp), perl(DynaLoader)
BuildRequires:   perl(Exporter), perl(overload), perl(strict), perl(TAP::Harness), perl(vars)
%ifnarch ppc64le
BuildRequires:   lm_sensors-devel >= 3
%endif
Requires:        %{name}-libs = %{version}-%{release}
Requires:        %{name}-agent-libs = %{version}-%{release}
%{?systemd_requires}

%description
Simple Network Management Protocol (SNMP) is a widely used protocol
for monitoring the health and welfare of network equipment (eg. routers),
computer equipment and even devices like UPSs. Net-SNMP is a suite of
applications used to implement SNMP v1, SNMP v2c and SNMP v3 using both
IPv4 and IPv6.

%package libs
Summary: The NET-SNMP runtime client libraries

%description libs
This package provides libraries for client applications.

%package agent-libs
Summary:   The NET-SNMP runtime agent libraries
Requires:  perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
Requires:  %{name}-libs = %{version}-%{release}

%description agent-libs
This package provides libraries for agent applications.

%package utils
Summary:  Network management utilities using SNMP, from the NET-SNMP project
Requires: %{name}-libs = %{version}-%{release}

%description utils
This package provides utilities for using the NET-SNMP network
management project.

%package perl
Summary:       The perl NET-SNMP module and the mib2c tool
BuildRequires: perl-interpreter, perl-generators
Requires:      %{name}-libs = %{version}-%{release}, perl-interpreter
Requires:      %{name}-agent-libs = %{version}-%{release}
Requires:      %{name}-devel = %{version}-%{release}

%description perl
This package provides the ability of using SNMP with perl.

%package -n python3-net-snmp
Summary:   The Python 'netsnmp' module for the Net-SNMP
Requires:  %{name}-libs = %{version}-%{release}
Provides:  %{name}-python = %{version}-%{release}

%description -n python3-net-snmp
This package provides python SNMP interface which rely on Net-SNMP
toolkit library.

%package devel
Summary:  The development environment for the NET-SNMP project
Requires: %{name}-libs = %{version}-%{release}
Requires: %{name}-agent-libs = %{version}-%{release}
Requires: elfutils-devel, rpm-devel, elfutils-libelf-devel, openssl-devel
%ifnarch ppc64le
Requires: lm_sensors-devel
%endif
Requires: perl-devel

%description devel
This package provides libraries and header files for developers who need to
use the NET-SNMP project's network management tools.

%prep
%autosetup -p1

%build
autoreconf

MIBS="host agentx smux \
     ucd-snmp/diskio tcp-mib udp-mib mibII/mta_sendmail \
     ip-mib/ipv4InterfaceTable ip-mib/ipv6InterfaceTable \
     ip-mib/ipAddressPrefixTable/ipAddressPrefixTable \
     ip-mib/ipDefaultRouterTable/ipDefaultRouterTable \
     ip-mib/ipv6ScopeZoneIndexTable ip-mib/ipIfStatsTable \
     sctp-mib rmon-mib etherlike-mib"

%ifnarch ppc64le
MIBS="$MIBS ucd-snmp/lmsensorsMib"
%endif

%configure \
    --enable-as-needed \
    --enable-blumenthal-aes \
    --enable-embedded-perl \
    --enable-ipv6 \
    --enable-local-smux \
    --enable-mfd-rewrites \
    --enable-ucd-snmp-compatibility \
    --disable-des \
    --with-openssl \
    --with-pic \
    --with-systemd \
    --with-mib-modules="$MIBS" \
    --with-perl-modules="INSTALLDIRS=vendor" \
    --with-security-modules=tsm  \
    --with-transports="DTLSUDP TLSTCP" \
    --with-temp-file-pattern=/run/net-snmp/snmp-tmp-XXXXXX \
    --with-persistent-directory="/var/lib/net-snmp" \
    --with-sys-contact="root@localhost" \
    --disable-static \
    --enable-shared \
    --with-cflags="$RPM_OPT_FLAGS -fPIE" \
    --with-ldflags="$RPM_LD_FLAGS -lm" \
    --without-pcre

%make_build

find perl/blib -type f -name "*.so" -print -exec chrpath --delete {} \;

pushd python
%{__python3} setup.py build --basedir="../"
popd


%install
make install DESTDIR=%{buildroot}

install -d %{buildroot}%{_sysconfdir}/snmp
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -m644 %SOURCE1 %{buildroot}%{_sysconfdir}/snmp/snmpd.conf
touch %{buildroot}%{_sysconfdir}/snmp/snmptrapd.conf
chmod 644 %{buildroot}%{_sysconfdir}/snmp/snmptrapd.conf
touch %{buildroot}%{_sysconfdir}/sysconfig/snmpd
chmod 644 %{buildroot}%{_sysconfdir}/sysconfig/snmpd
touch %{buildroot}%{_sysconfdir}/sysconfig/snmptrapd
chmod 644 %{buildroot}%{_sysconfdir}/sysconfig/snmptrapd

install -d %{buildroot}%{_localstatedir}/lib/net-snmp
install -d %{buildroot}%{_localstatedir}/lib/net-snmp/mib_indexes
install -d %{buildroot}%{_localstatedir}/lib/net-snmp/cert_indexes
install -d %{buildroot}%{_localstatedir}/run/net-snmp


find %{buildroot} -name perllocal.pod \
    -o -name .packlist \
    -o -name "*.bs" \
    -o -name Makefile.subs.pl \
    | xargs -ri rm -f {}
rm -f %{buildroot}%{_libdir}/*.la
rm -f README.aix README.hpux11 README.osX README.Panasonic_AM3X.txt README.solaris README.win32
rm -f %{buildroot}%{_bindir}/tkmib
rm -f %{buildroot}%{_mandir}/man1/tkmib.1*

pushd python
%{__python3} setup.py --basedir=.. install -O1 --skip-build --root %{buildroot} 
popd

find %{buildroot} -type f -name "*.so*" -o -type f -executable -print -exec chrpath --delete {} \;

chmod 755 local/passtest
chmod 644 local/ipf-mod.pl

install -m755 -d %{buildroot}/%{_tmpfilesdir}
install -m644 %SOURCE2 %{buildroot}/%{_tmpfilesdir}/net-snmp.conf
install -m755 -d %{buildroot}/%{_unitdir}
install -m644 %SOURCE3 %SOURCE4 %{buildroot}/%{_unitdir}/

%check
# by pass some unstable tests
rm -f testing/fulltests/default/{T070com2sec_simple,T071com2sec6_simple}
LD_LIBRARY_PATH=%{buildroot}/%{_libdir} make test

%post
%systemd_post snmpd.service snmptrapd.service

%preun
%systemd_preun snmpd.service snmptrapd.service

%postun
%systemd_postun_with_restart snmpd.service snmptrapd.service

%files
%license COPYING
%doc ChangeLog EXAMPLE.conf FAQ NEWS TODO
%doc README README.agent-mibs README.agentx README.krb5 README.snmpv3
%doc local/passtest local/ipf-mod.pl
%doc README.thread AGENT.txt PORTING local/README.mib2c
%{_bindir}/snmpinform
%{_bindir}/snmpcheck
%{_bindir}/fixproc
%{_bindir}/ipf-mod.pl
%{_bindir}/snmpconf
%{_bindir}/net-snmp-create-v3-user
%{_bindir}/agentxtrap
%{_sbindir}/*
%dir %{_datadir}/snmp
%{_datadir}/snmp/snmpconf-data
%dir %{_localstatedir}/run/net-snmp
%{_tmpfilesdir}/net-snmp.conf
%{_unitdir}/snmp*
%dir %{_sysconfdir}/snmp
%config(noreplace) %attr(0600,root,root) %{_sysconfdir}/snmp/snmpd.conf
%config(noreplace) %attr(0600,root,root) %{_sysconfdir}/snmp/snmptrapd.conf
%config(noreplace) %{_sysconfdir}/sysconfig/snmpd
%config(noreplace) %{_sysconfdir}/sysconfig/snmptrapd
%attr(0644,root,root) %{_mandir}/man1/fixproc*
%attr(0644,root,root) %{_mandir}/man1/agentxtrap.1*
%attr(0644,root,root) %{_mandir}/man[58]/snmp*d*
%attr(0644,root,root) %{_mandir}/man5/snmp_config.5.gz
%attr(0644,root,root) %{_mandir}/man5/variables*
%attr(0644,root,root) %{_mandir}/man1/net-snmp-create-v3-user*
%attr(0644,root,root) %{_mandir}/man1/snmpconf.1.gz

%files libs
%{_libdir}/libnetsnmp.so*
%{_libdir}/libsnmp*
%dir %{_datadir}/snmp
%dir %{_datadir}/snmp/mibs
%{_datadir}/snmp/mibs/*
%dir %{_localstatedir}/lib/net-snmp
%dir %{_localstatedir}/lib/net-snmp/mib_indexes
%dir %{_localstatedir}/lib/net-snmp/cert_indexes

%files agent-libs
%{_libdir}/libnetsnmpagent*.so*
%{_libdir}/libnetsnmphelpers*.so*
%{_libdir}/libnetsnmpmibs*.so*
%{_libdir}/libnetsnmptrapd*.so*

%files utils
%{_bindir}/encode_keychange
%{_bindir}/snmp[^c-]*
%attr(0644,root,root) %{_mandir}/man1/snmp[^-]*.1*
%attr(0644,root,root) %{_mandir}/man1/encode_keychange*.1*
%attr(0644,root,root) %{_mandir}/man5/snmp.conf.5.gz
%attr(0644,root,root) %{_mandir}/man5/variables.5.gz

%files perl
%{_bindir}/mib2c-update
%{_bindir}/mib2c
%{_bindir}/snmp-bridge-mib
%{_bindir}/net-snmp-cert
%{_bindir}/checkbandwidth
%{_bindir}/traptoemail
%dir %{_datadir}/snmp
%{_datadir}/snmp/mib2c*
%{_datadir}/snmp/*.pl
%attr(0644,root,root) %{_mandir}/man[15]/mib2c*
%attr(0644,root,root) %{_mandir}/man3/*.3pm.*
%attr(0644,root,root) %{_mandir}/man1/traptoemail*.1*
%attr(0644,root,root) %{_mandir}/man1/snmp-bridge-mib.1*
%{perl_vendorarch}/*SNMP*
%{perl_vendorarch}/auto/*SNMP*
%{perl_vendorarch}/auto/Bundle/*SNMP*
%{perl_vendorarch}/Bundle/MakefileSubs.pm

%files -n python3-net-snmp
%{python3_sitearch}/*

%files devel
%{_bindir}/net-snmp-config*
%{_libdir}/pkgconfig/*
%{_includedir}/*
%attr(0644,root,root) %{_mandir}/man3/*.3.*
%attr(0644,root,root) %{_mandir}/man1/net-snmp-config*.1.*

%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.9.3-6
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.9.3-5
- Rebuilt for loongarch release

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.9.3-4
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.9.3-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Aug 18 2023 Wang Guodong <gordonwwang@tencent.com> - 5.9.3-2
- Rebuilt for mariadb-connector-c 3.3.5

* Thu Aug 3 2023 Shuo Wang <abushwang@tencent.com> - 5.9.3-1
- update to 5.9.3

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.9.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.9.1-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Nov 25 2022 cunshunxia <cunshunxia@tencent.com> - 5.9.1-2
- move net-snmp-config from main pkg to devel.
* Mon Jun 27 2022 cunshunxia <cunshunxia@tencent.com> - 5.9.1-1
- initial build
